using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GridSweeperCS {
	public partial class Form1 : Form {
		int cellSize = 20; // Z̃TCY
		int sx = 16; // tB[h̕
		int sy = 16; // tB[h̍
		int numMine = 40; // e̐

		const int UNOPEN = -2;
		const int MINE = -1;

		int numCellOpened; // JZ̐
		bool gameStarted; // Q[JnĂ邩

		public Form1() {
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e) {
			// ȉ̓vpeBEEBhEłݒ\
			dgv.ReadOnly = true;
			dgv.ColumnHeadersVisible = false;
			dgv.RowHeadersVisible = false;
			dgv.AllowUserToResizeColumns = false;
			dgv.AllowUserToResizeRows = false;
			dgv.AllowUserToAddRows = false;
			dgv.ShowCellToolTips = false; // Ȃ悤

			// tB[h̍쐬
			dgv.RowTemplate.Height = cellSize; // ǉs̍
			dgv.ColumnCount = sx;
			dgv.RowCount = sy;
			foreach (DataGridViewColumn col in dgv.Columns) {
				col.Width = cellSize;
			}

			// tH[̃TCYDGVɍ킹
			DataGridViewCell cell = dgv[0, 0];
			this.ClientSize = new Size(
			  cell.Size.Width * sx + 3,
			  cell.Size.Height * sy + 3);

			initGame();
		}

		// Q[̏
		void initGame() {
			numCellOpened = 0;
			gameStarted = true;

			// ׂẴZ̏
			for (int x = 0; x < sx; x++) {
				for (int y = 0; y < sy; y++) {
					dgv[x, y].Value = UNOPEN;
					dgv[x, y].Style.ForeColor = Color.WhiteSmoke;
					dgv[x, y].Style.BackColor = Color.WhiteSmoke;
				}
			}

			// e̔zu
			Random rnd = new Random();
			for (int doneNum = 0; doneNum < numMine; ) {
				int x = rnd.Next(sx);
				int y = rnd.Next(sy);
				if ((int)dgv[x, y].Value != MINE) {
					dgv[x, y].Value = MINE;
					doneNum++;
				}
			}

			showRemain();
		}

		// cZiJĂȂZj̕\
		void showRemain() {
			this.Text = "eF" + numMine
			  + " c̃ZF" + (sx * sy - numCellOpened);
		}

		// (x, y)ObhɊ܂܂邩
		bool isInField(int x, int y) {
			if (x < 0 || y < 0 || x >= sx || y >= sy)
				return false;
			return true;
		}

		// cellɗאڂZzŕԂ
		DataGridViewCell[] getNeighbors(DataGridViewCell cell) {
			int x = cell.ColumnIndex;
			int y = cell.RowIndex;
			List<DataGridViewCell> cc = new List<DataGridViewCell>();

			if (isInField(x - 1, y - 1)) cc.Add(dgv[x - 1, y - 1]);
			if (isInField(x - 1, y + 1)) cc.Add(dgv[x - 1, y + 1]);
			if (isInField(x + 1, y - 1)) cc.Add(dgv[x + 1, y - 1]);
			if (isInField(x + 1, y + 1)) cc.Add(dgv[x + 1, y + 1]);
			if (isInField(x - 1, y)) cc.Add(dgv[x - 1, y]);
			if (isInField(x + 1, y)) cc.Add(dgv[x + 1, y]);
			if (isInField(x, y - 1)) cc.Add(dgv[x, y - 1]);
			if (isInField(x, y + 1)) cc.Add(dgv[x, y + 1]);

			return cc.ToArray();
		}

		// Z̕\
		void drawNumberCell(DataGridViewCell cell) {
			cell.Style.BackColor = Color.LightGray;
			if ((int)cell.Value == 0) {
				// 0͕\ȂiwiFŕ`j
				cell.Style.ForeColor = Color.LightGray;
			} else {
				// 1`8̐
				cell.Style.ForeColor = Color.Blue;
			}
		}

		// ZJƂ
		void tryCell(DataGridViewCell cell) {
			if (gameStarted == false) {
				return;
			}
			if ((int)cell.Value == MINE) {
				gameOver(false);
			} else if ((int)cell.Value == UNOPEN) {
				openCell(cell);
				showRemain();
				if (numCellOpened == sx * sy - numMine) {
					gameOver(true);
				}
			}
		}

		// ZJ
		void openCell(DataGridViewCell cell) {
			numCellOpened++;
			int count = 0;

			// ̔e̐𐔂
			foreach (DataGridViewCell c in getNeighbors(cell)) {
				if ((int)c.Value == MINE) {
					count++;
				}
			}

			// ̔e̐\
			cell.Value = count;
			drawNumberCell(cell);

			// ̃ZɔeȂꍇÃZJ
			if (count == 0) {
				foreach (DataGridViewCell c in getNeighbors(cell)) {
					if ((int)c.Value == UNOPEN) {
						openCell(c); // ċAĂяo
					}
				}
			}
		}

		void gameOver(bool isSuccess) {
			gameStarted = false;
			this.Text = "F2L[ŃgC";

			// eʒu̕\
			for (int x = 0; x < sx; x++) {
				for (int y = 0; y < sy; y++) {
					if ((int)dgv[x, y].Value == MINE) {
						dgv[x, y].Value = "";
						dgv[x, y].Style.BackColor
						  = isSuccess ? Color.Green : Color.Red;
					}
				}
			}
		}

		// DGVKeyDownCxgEnh
		private void dgv_KeyDown(object sender, KeyEventArgs e) {
			if (e.KeyCode == Keys.F2) {
				initGame();
			}
			if (e.KeyCode == Keys.Space) {
				tryCell(dgv.CurrentCell);
			}
		}

		// DGVCellClickCxgEnh
		private void dgv_CellClick(object sender, DataGridViewCellEventArgs e) {
			tryCell(dgv[e.ColumnIndex, e.RowIndex]);
		}

		// DGVSelectionChangedCxgEnh
		private void dgv_SelectionChanged(object sender, EventArgs e) {
			// ZIԂɂȂ
			dgv.ClearSelection();
		}
	}
}
